<?php
/*
* @package JoomShopping for Joomla!
* @subpackage payment
* @author CM-S.ru
* @copyright Copyright (C) 2012-2013 CM-S.ru. All rights reserved.
* @license GNU General Public License version 2 or later
*/

//защита от прямого доступа
defined('_JEXEC') or die();

class pm_onpay extends PaymentRoot
{
	function showPaymentForm($params, $pmconfigs)
	{
		include(dirname(__FILE__).'/paymentform.php');
	}
	
	//функция подключает языковый файл
	function loadLanguageFile()
	{
		$lang = JFactory::getLanguage();
		$langtag = $lang->getTag(); //определяем текущий язык

		if (file_exists(JPATH_ROOT.'/components/com_jshopping/payments/pm_onpay/lang/'.$langtag.'.php')) {
			require_once(JPATH_ROOT.'/components/com_jshopping/payments/pm_onpay/lang/'.$langtag.'.php');
		} else { 
			require_once(JPATH_ROOT.'/components/com_jshopping/payments/pm_onpay/lang/en-GB.php'); //если языковый файл не найден, то подключаем en-GB.php
		}
	}
	
	//функция показывает настройки плагина в админке
	function showAdminFormParams($params)
	{
		$array_params = array('onpay_login', 'onpay_secret_key', 'transaction_end_status', 'transaction_pending_status', 'transaction_failed_status');
		
		foreach ($array_params as $key) {
			if (!isset($params[$key])) {
				$params[$key] = '';
			}
		}

		$orders = JModelLegacy::getInstance('orders', 'JshoppingModel');
		
		$this->loadLanguageFile(); //подключаем нужный язык
		
		include(dirname(__FILE__).'/adminparamsform.php');
	}
	
	//функция выдает ответ для сервиса onpay в формате XML на чек запрос 
	function answer($type, $code, $pay_for, $order_amount, $order_currency, $text, $pmconfigs)
	{ 
		$md5 = strtoupper(md5("{$type};{$pay_for};{$order_amount};{$order_currency};{$code};".$pmconfigs['onpay_secret_key'])); 
		
		return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<result>\n<code>{$code}</code>\n<pay_for>{$pay_for}</pay_for>\n<comment>{$text}</comment>\n<md5>{$md5}</md5>\n</result>";
	}
	
	//функция выдает ответ для сервиса onpay в формате XML на pay запрос 
	function answerpay($type, $code, $pay_for, $order_amount, $order_currency, $text, $onpay_id, $pmconfigs)
	{ 
		$md5 = strtoupper(md5("{$type};{$pay_for};{$onpay_id};{$pay_for};{$order_amount};{$order_currency};{$code};".$pmconfigs['onpay_secret_key'])); 
	
		return "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<result>\n<code>{$code}</code>\n<comment>{$text}</comment>\n<onpay_id>{$onpay_id}</onpay_id>\n<pay_for>{$pay_for}</pay_for>\n<order_id>{$pay_for}</order_id>\n<md5>{$md5}</md5>\n</result>"; 
	}
	
	//функция выводит результат в XML формате, в ответ на запрос сервера onpay
	function nofityFinish($pmconfigs, $order, $rescode)
	{
		die("___rez___\n".$this->rezult); //строка ___rez___ служит меткой для отделения заголовков от тела результата
	}
	
	//проверка входных данных от onpay
	function checkTransaction($pmconfigs, $order, $act)
	{
		$order->order_total = $this->to_float($order->order_total); //приводим сумму заказа в нужный формат
		
		$this->rezult = '';
		$error = '';
		//получаем данные, что нам прислал запрос 
		$type = JRequest::getVar('type');
		$order_amount = $this->to_float(JRequest::getVar('order_amount'));
		$pay_for = JRequest::getVar('pay_for');
		$order_currency = JRequest::getVar('order_currency');
		
		$this->loadLanguageFile(); //подключаем нужный язык
		
		//проверяем чек запрос 
		if ($type == 'check') { 
			//выдаем ответ OK на чек запрос 
			die("___rez___\n".$this->answer($type, 0, $pay_for, $order_amount, $order_currency, 'OK', $pmconfigs)); 
		}
		
		//проверяем pay запрос 
		if ($type == 'pay') { 
			//получаем данные
			$onpay_id = JRequest::getVar('onpay_id'); 
			$balance_amount = JRequest::getVar('balance_amount'); 
			$balance_currency = JRequest::getVar('balance_currency'); 
			$exchange_rate = JRequest::getVar('exchange_rate'); 
			$md5 = JRequest::getVar('md5'); 
			
			//производим проверки входных данных 
			if (empty($onpay_id)) {
				$error .= _JSHOP_ERROR_ONPAY_ID.'<br>';
			} else {
				if (!is_numeric(intval($onpay_id))) {
					$error .= _JSHOP_ERROR_ONPAY_NOT_NUM.'<br>';
				}
			}
			
			if (empty($order_amount)) {
				$error .= _JSHOP_ERROR_ONPAY_SUM.'<br>';
			} else {
				if (!is_numeric($order_amount)) {
					$error .= _JSHOP_ERROR_ONPAY_NOT_NUM.'<br>';
				}
			}
			 
			if (empty($balance_amount)) {
				$error .= _JSHOP_ERROR_ONPAY_SUM.'<br>';
			} else {
				if (!is_numeric(intval($balance_amount))) {
					$error .= _JSHOP_ERROR_ONPAY_NOT_NUM.'<br>';
				}
			}
			 
			if (empty($balance_currency)) {
				$error .= _JSHOP_ERROR_ONPAY_CUR.'<br>';
			} else {
				if (strlen($balance_currency) > 4) {
					$error .= _JSHOP_ERROR_ONPAY_TOLONG.'<br>';
				}
			}
			 
			if (empty($order_currency)) {
				$error .= _JSHOP_ERROR_ONPAY_CUR.'<br>';
			} else {
				if (strlen($order_currency) > 4) {
					$error .= _JSHOP_ERROR_ONPAY_TOLONG.'<br>';
				}
			}
			 
			if (empty($exchange_rate)) {
				$error .= _JSHOP_ERROR_ONPAY_SUM.'<br>';
			} else {
				if (!is_numeric($exchange_rate)) {
					$error .= _JSHOP_ERROR_ONPAY_NOT_NUM.'<br>';
				}
			} 

			//если нет ошибок 
			if (!$error) { 
				if ($pay_for) {
					//создаем строку хэша с присланных данных 
					$md5fb = strtoupper(md5($type.";".$pay_for.";".$onpay_id.";".$order_amount.";".$order_currency.";".$pmconfigs['onpay_secret_key'])); 
					//сверяем строчки хеша (присланную и созданную нами) 
					if ($md5fb != $md5) {
						$this->rezult = $this->answerpay($type, 8, $pay_for, $order_amount, $order_currency, _JSHOP_ERROR_ONPAY_MD5, $onpay_id, $pmconfigs);
						return array(0, _JSHOP_ERROR_ONPAY_MD5);
					} else { 
						$this->rezult = $this->answerpay($type, 0, $pay_for, $order_amount, $order_currency, 'OK', $onpay_id, $pmconfigs);
						return array(1, '');
					}
				} else {
					//если pay_for - не правильный формат 
					$this->rezult = $this->answerpay($type, 11, $pay_for, $order_amount, $order_currency, _JSHOP_ERROR_ONPAY_PARAM, $onpay_id, $pmconfigs); 
					return array(0, _JSHOP_ERROR_ONPAY_PARAM);
				} 
			} else {
				//если есть ошибки 
				$this->rezult = $this->answerpay($type, 12, $pay_for, $order_amount, $order_currency, _JSHOP_ERROR_ONPAY_PARAM.': '.$error, $onpay_id, $pmconfigs);
				return array(0, _JSHOP_ERROR_ONPAY_PARAM.': '.$error);
			} 
		} 
	
		return array(0, _JSHOP_ERROR_ONPAY_RESP.' '.$order->order_id);                    
	}

	//функция показывает форму оплаты
	function showEndForm($pmconfigs, $order)
	{
		$login = $pmconfigs['onpay_login'];
		$secret_key = $pmconfigs['onpay_secret_key'];
		$price_final = $pmconfigs['price_final'] ? 'true' : 'false';
		$add_params = trim($pmconfigs['add_params'], '&');
		$order_id = $order->order_id;
		$currency = $order->currency_code_iso;
		$email = $order->email;
		$total = $order->order_total;
		$total_md5 = $this->to_float($total);
		$md5check = md5('fix;'.$total_md5.';'.$currency.';'.$order_id.';yes;'.$secret_key); 
		
		$url_success = urlencode(JURI::root(false, '').'pluginresponsereceived');
		$url_fail = urlencode(JURI::root(false, '').'pluginresponsecancel');

		$url = 'http://secure.onpay.ru/pay/'.$login.'?pay_mode=fix&pay_for='.$order_id.'&price='.$total.'&ticker='.$currency.'&md5='.$md5check.'&user_email='.$email.'&url_success_enc='.$url_success.'&url_fail_enc='.$url_fail.'&price_final='.$price_final.'&'.$add_params; //формируем строку url ?>
		<html>
			<head>
				<meta http-equiv="content-type" content="text/html; charset=utf-8" />           
			</head>
			<body>
				<form id="paymentform" action="<?php echo $url; ?>" name="paymentform" method="post">
					<div><img src="http://onpay.ru/images/onpay_logo.gif" alt="" /></div>
				</form>
			<?php echo _JSHOP_REDIRECT_TO_PAYMENT_PAGE; ?>
			<br>
			<script type="text/javascript">document.getElementById('paymentform').submit();</script>
			</body>
		</html>
		<?php
		die();
	}

	//функция переводит число в нужный формат
	function to_float($sum)
	{ 
		$sum = round(floatval($sum), 2);
		$sum = sprintf('%01.2f', $sum);
		
		if (substr($sum, -1) == '0') {
			$sum = sprintf('%01.1f', $sum);
		}
		
		return $sum;
	}

	//функция определяет ID заказа
	function getUrlParams($pmconfigs)
	{      
		$params = array(); 
		$params['order_id'] = JRequest::getInt('pay_for');
		$params['hash'] = '';
		$params['checkHash'] = 0;
		$params['checkReturnParams'] = 0;

		return $params;
	}
}
?>